<?php

// Current datafeed script version
$script_version = "1.01";

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();


##### Include configuration files ################################################

$path_config = "./";

if(!file_exists($path_config . "config.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Va rugam sa copiati fisierul in directorul /root al site-ului</BODY></HTML>');
}
else {
	require($path_config . "config.php");
}

// Startup
require_once(DIR_SYSTEM . 'startup.php');

// Registry
$registry = new Registry();

// Loader
$loader = new Loader($registry);
$registry->set('load', $loader);

// Config
$config = new Config();
$registry->set('config', $config);

// Database 
// Database 
$db = new DB(DB_DRIVER, DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);
$registry->set('db', $db);

// Request
$request = new Request();

####################################################################

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";
$language_code = (@$_GET['language'] != "") ? $_GET['language'] : "";
$language_id = (@$_GET['language_id'] != "") ? $_GET['language_id'] : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";

####################################################################


// Get currency
if($currency != "") {
	$add_currency = 1;
	$currency_code = $_GET['currency']; 
}
else {
	$add_currency = 0;
}

if (!defined('HTTP_SERVER')) {
	define('HTTP_SERVER', 'http://' . $_SERVER['HTTP_HOST'] . rtrim(dirname($_SERVER['PHP_SELF']), '/') . '/');
}
if (!defined('HTTP_IMAGE')) {
	define('HTTP_IMAGE', HTTP_SERVER . 'image/');
}

// Get http_server and image directory
$http_server = HTTP_SERVER;
$image_directory = HTTP_IMAGE;


// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed OpenCart</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	exit;
}

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed OpenCart</b><br />";
	echo "script version <b>" . $script_version . "</b><br /><br /><br />";
		
	//echo "Taxes options - possible values on, off default value on<br />";
	//echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	//echo "Store taxes options - possible values on, off default value on<br />";
	//echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	//echo "Discount options - possible values on, off default value on<br />";
	//echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "Add VAT to prices - possible values on, off default value on<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "VAT value - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
	
	//echo "Add shipping to datafeed - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "Add GA Tagging to product URL - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "Tagging to product URL - possible values url_encode(TAGGING_PARAMS) default value tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=%26from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=%26from%3Dshopmania" . "</a><br /><br />";
	
	echo "Display Description options - possible values on, off<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	echo "Display image options - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "Show only on stock products - possible values on, off default value off<br />";
	echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	echo "Show SEO friendly url - possible values on, off default value off<br />";
	echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	echo "Get prices in specified currency - possible values USD,EUR etc. <br />";
	echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	echo "Get texts in specified language code - possible values en,ro etc. <br />";
	echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	echo "<br />";
	
	exit;
	
}


##### Extract options from database ################################################


if ($language_id > 0) {
	// Set the main language
	$main_language = $language_id;
}
elseif ($language_code != "") {
	// Detect default language ID
	$query_language_id = mysql_query("SELECT language_id FROM " . DB_PREFIX . "language WHERE code='" . $language_code . "' LIMIT 1") or die("Language id: " . mysql_error());
	$row_language_id = mysql_fetch_array($query_language_id);

	// Set the main language
	$main_language = $row_language_id['language_id'];
}
else {
	// Detect default language code
	$query_language_code = mysql_query("SELECT value FROM " . DB_PREFIX . "setting WHERE " . DB_PREFIX . "setting.key='config_language'") or die("Language code: " . mysql_error());
	$row_language_code = mysql_fetch_array($query_language_code);

	$language_code = $row_language_code['value'];
	
	// Detect default language ID
	$query_language_id = mysql_query("SELECT language_id FROM " . DB_PREFIX . "language WHERE code='" . $language_code . "' LIMIT 1") or die("Language id: " . mysql_error());
	$row_language_id = mysql_fetch_array($query_language_id);

	// Set the main language
	$main_language = $row_language_id['language_id'];
}


// Get default currency
$res_currency = mysql_query("SELECT value FROM " . DB_PREFIX . "setting WHERE " . DB_PREFIX . "setting.key='config_currency'") or die("Currency code: " . mysql_error());
if ($res_currency) {
	while ($field = mysql_fetch_assoc($res_currency)) {
		$datafeed_currency = $field['value'];
	}
}

if ($add_currency == 1) {
	$res_currency_2 = mysql_query("SELECT value FROM " . DB_PREFIX . "currency WHERE code LIKE '" . $_GET['currency'] . "'");
	if ($res_currency_2) {
		$field = mysql_fetch_assoc($res_currency_2);
		$currency_value = $field['value'];
		$datafeed_currency = strtoupper($_GET['currency']);
	}
}

// Get categories
$cat_res = mysql_query("SELECT * FROM " . DB_PREFIX . "category 
	LEFT JOIN " . DB_PREFIX . "category_description ON (" . DB_PREFIX . "category.category_id = " . DB_PREFIX . "category_description.category_id) 
	WHERE language_id = '" . $main_language . "'") or die("Category: " . mysql_error());
if ($cat_res) {
	while($field = mysql_fetch_assoc($cat_res)) {
		$CAT_ARR[$field['category_id']] = $field;
	}
}

// Get special prices for product
$res_special_price = mysql_query("SELECT product_id, price 
	FROM " . DB_PREFIX . "product_special
	WHERE (date_start <= DATE_FORMAT(NOW(), '%Y-%m-%d') OR date_start = '0000-00-00') AND (date_end >= DATE_FORMAT(NOW(), '%Y-%m-%d') OR date_end = '0000-00-00')
	ORDER BY customer_group_id DESC") or die(mysql_error());

if ($res_special_price) {
	while ($field = mysql_fetch_assoc($res_special_price)) {
		$SPECIAL_PRICE[$field['product_id']] = $field['price'];
	}
}

// Get special prices for product
$res_setting = mysql_query("SELECT * FROM " . DB_PREFIX . "setting WHERE " . DB_PREFIX . "setting.group='config' ") or die(mysql_error());

if ($res_setting) {
	while ($field = mysql_fetch_assoc($res_setting)) {
		$SETTING[$field['key']] = $field['value'];
	}
}

######################################################################


##### Extract products from database ###############################################

// Get product data
$qry = "SELECT " . DB_PREFIX . "product_to_category.category_id, " . DB_PREFIX . "manufacturer.name as prod_manufacturer, " . DB_PREFIX . "product.model as prod_model, " . DB_PREFIX . "product.product_id as prod_id, " . DB_PREFIX . "product.tax_class_id, " . DB_PREFIX . "product_description.name as prod_name, " . DB_PREFIX . "product_description.description as prod_desc, " . DB_PREFIX . "product.image as prod_image, " . DB_PREFIX . "product.price as prod_price, " . DB_PREFIX . "tax_rate.rate
	FROM " . DB_PREFIX . "product
	LEFT JOIN " . DB_PREFIX . "product_description ON (" . DB_PREFIX . "product.product_id = " . DB_PREFIX . "product_description.product_id AND " . DB_PREFIX . "product_description.language_id = " . $main_language . ")
	LEFT JOIN " . DB_PREFIX . "manufacturer ON " . DB_PREFIX . "product.manufacturer_id = " . DB_PREFIX . "manufacturer.manufacturer_id
	LEFT JOIN " . DB_PREFIX . "product_to_category ON " . DB_PREFIX . "product.product_id = " . DB_PREFIX . "product_to_category.product_id
	LEFT JOIN " . DB_PREFIX . "tax_rate ON " . DB_PREFIX . "product.tax_class_id = " . DB_PREFIX . "tax_rate.tax_class_id
	WHERE " . DB_PREFIX . "product.status = '1'
	ORDER BY " . DB_PREFIX . "product.product_id ASC, " . DB_PREFIX . "product_to_category.category_id DESC";
$res_products = mysql_query($qry);

###################################################################


##### Print product data ####################################################

$current_id = 0;

header('Content-Type:text/xml; charset=UTF-8');
echo "<?xml version=\"1.0\"?>\r\n<products>\r\n";

if (!mysql_error()) {
	while ($row = mysql_fetch_assoc($res_products)) {
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		
		$prod_id = $row['prod_id'];
		if ($current_id == $prod_id) {
			continue;
		}
		else {
			$current_id = $prod_id;
		}
		
		// Get category name
		@$category_name = smfeed_get_full_cat($row['category_id'], $CAT_ARR);
		
		// Get manufacturer
		@$prod_manufacturer = $row['prod_manufacturer'];

		// Get product model
		$prod_model = $row['prod_model'];

		// Get name and description for product
		$prod_name = $row['prod_name'];
		if ($show_description == "off") {
			$prod_desc = "";
		}
		else {
			$prod_desc = $row['prod_desc'];
		}

		// Clean product name (new lines)
		$prod_name = str_replace("\n", "", strip_tags($prod_name));
		$prod_name = str_replace("\r", "", strip_tags($prod_name));
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));

		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
		$prod_desc = str_replace("\n", " ", $prod_desc);		
		$prod_desc = str_replace("\r", "", $prod_desc);
		$prod_desc = str_replace("\t", " ", $prod_desc);
		$prod_desc = html_entity_decode($prod_desc);

			// Get product image
		$prod_image = $row['prod_image'];
		$prod_image = smfeed_get_product_image($prod_image, $image_directory);

		// Get product price
		
		if (@$SPECIAL_PRICE[$prod_id]) {
			$prod_price = $SPECIAL_PRICE[$prod_id];
		}
		else {
			$prod_price = $row['prod_price'];
		}
		
		// Add tax rate
		$tax_rate = $row['rate'];
		if ($tax_rate > 0 && $SETTING['config_tax'] == 1) {
			$prod_price = $prod_price +($prod_price * $tax_rate / 100);
		}
				
		// Add VAT to prices
		if ($add_vat == "on") {
			$prod_price = $prod_price * $vat_value;
		}
		
		// Get conversion to wanted currency
		if ($add_currency == 1) {
			$prod_price = $prod_price * $currency_value;
		}
		
		$words = explode('>',$category_name);
		foreach($words as $word) { if (strlen(trim($word))>0) {$category_name = trim($word);break;}}

		$prod_name = substr($prod_name, 0, 120);
		$prod_desc = substr($prod_desc, 0, 8000);

		// Output the datafeed content
	echo "<product>\r\n";
		echo "\t<id>".$prod_id.'</id>'."\r\n";
		echo "\t<name><![CDATA[".$prod_name.']]></name>'."\r\n";
		echo "\t<model><![CDATA[".$prod_model.']]></model>'."\r\n";
		echo "\t<keywords/>\r\n";
		echo "\t<details><![CDATA[".$prod_desc.']]></details>'."\r\n";
		echo "\t<category><![CDATA[".$category_name.']]></category>'."\r\n";
		echo "\t<available>1</available>\r\n";
		echo "\t<canBeOrderedOnline>1</canBeOrderedOnline>\r\n";
		echo "\t<price>".$prod_price.'</price>'."\r\n";
		echo "\t<currency>".$datafeed_currency."</currency>\r\n";
		echo "\t<pictures>\r\n";
			echo "\t\t<picture><![CDATA[".$prod_image."]]></picture>\r\n";
		echo "\t</pictures>\r\n";
		echo "</product>\r\n";
		
	}
}
else {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Query error: " . mysql_error() . "</BODY></HTML>";
}

echo "</products>\r\n";
###################################################################

##### Functions ########################################################

function smfeed_get_seo_url($prod_name, $http_server){
	return $http_server . smfeed_build_str_key($prod_name);
}

function smfeed_get_product_url($prod_id, $http_server) {
	return $http_server . "index.php?route=product/product&product_id=" . $prod_id;
}

function smfeed_get_product_image ($prod_image, $image_directory) {
	
	if ($prod_image != "") {
		$image_src = $image_directory . $prod_image; 	
	}
	else {
		$image_src = ""; 	
	}
	
	return $image_src;
	
}


function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

function smfeed_build_str_key($text){
	
	$text = str_replace(" ", "-", trim(smfeed_string_clean_search($text)));
	$text = rawurlencode(strtolower($text));
	
	$text = strtolower(smfeed_clean_accents($text));
	
	return $text;
}

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['name'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['name'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i",
		"'&#(\d+);'e"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		"uchr(\\1)"
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

// Clean accesnts
function smfeed_clean_accents($text){

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// Clean strings
function smfeed_string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'\+'",
		"'='",
		"'\.'",
		"','",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'/'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
	);
	
	$replace = array (
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

###################################################################

exit;

?>