<?php

error_reporting(E_ALL ^ E_NOTICE);

$path_config = "./";

if(!file_exists($path_config . "config.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that shopspot_opencart.php is in the same folder with config.php file or define the path to config.php file in $path_config variable.</BODY></HTML>');
}
else {
	require($path_config . "config.php");
}

// Locator
include(DIR_LIBRARY . 'locator.php');
$locator =& new Locator();

// Config
$config =& $locator->get('config');

// Database
$database =& $locator->get('database');

// Settings
$settings = $database->getRows("SELECT * FROM setting WHERE type = 'catalog' OR type = 'global'");

foreach ($settings as $setting) {
	$config->set($setting['key'], $setting['value']);
}

// Language
$language =& $locator->get('language');

// URL
$url =& $locator->get('url');

// Image
$image =& $locator->get('image');

// Currency
$currency =& $locator->get('currency');

// Tax
$tax =& $locator->get('tax');

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

// Get product/category relations
$prod_cat_res = $database->getRows("SELECT * FROM product_to_category ORDER BY category_id ASC");
foreach ($prod_cat_res as $result) {
	$PROD_CAT_ARR[$result['product_id']] = $result['category_id'];
}

// Get categories
$cat_res = $database->getRows("SELECT * FROM category LEFT JOIN category_description ON (category.category_id = category_description.category_id) WHERE language_id = '" . (int)$language->getId() . "'");
foreach ($cat_res as $result) {
	$CAT_ARR[$result['category_id']] = $result;
}

// Get categories
$mnf_res = $database->getRows("SELECT * FROM manufacturer");
foreach ($mnf_res as $result) {
	$MNF_ARR[$result['manufacturer_id']] = $result;
}

$product_data = array();

$results = $database->getRows("SELECT * 
FROM product p 
LEFT JOIN product_description pd ON (p.product_id = pd.product_id) 
LEFT JOIN image i ON (p.image_id = i.image_id) 
WHERE p.status = '1' AND pd.language_id = '" . (int)$language->getId() . "' AND p.date_available < now()");

foreach ($results as $result) {

	$cat_name = get_full_cat($PROD_CAT_ARR[$result['product_id']], $CAT_ARR);
	$prod_manufacturer = $MNF_ARR[$result['manufacturer_id']]['name'];
	$prod_model = $result['model'];
	$prod_id = $result['product_id'];
	$prod_name = $result['name'];
	$prod_desc = $result['description'];
	$prod_url = $url->href('product', FALSE, array('product_id' => $result['product_id']));
	$prod_image = $image->href($result['filename']);
	$prod_price = $tax->calculate($result['price'], $result['tax_class_id'], $config->get('config_tax'));
	$datafeed_currency = $currency->code;
	
	// Clean product name (new lines)
	$prod_name = str_replace("\n", "", strip_tags($prod_name));
	// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
	$prod_desc = replace_not_in_tags("\n", "<BR />", $prod_desc);
	$prod_desc = str_replace("\n", " ", $prod_desc);	
	$prod_desc = str_replace("\r", "", $prod_desc);
	
	// Clean product names and descriptions (separators)
	if ($datafeed_separator == "\t") {
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));
		$prod_desc = str_replace("\t", " ", $prod_desc);
	}
	elseif ($datafeed_separator == "|") {
		$prod_name = str_replace("|", " ", strip_tags($prod_name));
		$prod_desc = str_replace("|", " ", $prod_desc);
	}
	else {
		print "Incorrect columns separator.";
		exit;			
	}
	
	// Output the datafeed content
	print 
	$cat_name . $datafeed_separator . 
	$prod_manufacturer . $datafeed_separator . 
	$prod_model . $datafeed_separator . 
	$prod_id . $datafeed_separator . 
	$prod_name . $datafeed_separator . 
	$prod_desc . $datafeed_separator . 
	$prod_url . $datafeed_separator . 
	$prod_image . $datafeed_separator . 
	$prod_price . $datafeed_separator . 	
	$datafeed_currency . "\n";

}

// Function to get category with full path
function get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['name'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['name'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	return $cat_name;
}

function replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

exit;

?>